//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
//
using System;
using System.Threading;

namespace ProfilingSamples
{
	public class GCLargeObjectMain 
	{
		private ManualResetEvent asyncEvent;
		void LargeThread()
		{
			byte [] ba = new byte[10000000];
			for(int i = 0; i < ba.Length; i++)
			{
				ba[i] = (byte)(i % 256);
			}
			asyncEvent.WaitOne();
			ba = null;
		}
		void TestThread()
		{
			Thread t;
			asyncEvent = new ManualResetEvent(false);
			try
			{
				while(true)
				{
					asyncEvent.Reset();
					t = new Thread(new ThreadStart(LargeThread));
					t.Start();

					Thread.Sleep(500);

					// Wykonanie GC zmienia generację obiektu
					GC.Collect();

					asyncEvent.Set();
					t.Join();

					Thread.Sleep(500);
					// Wykonanie GC zmienia generację obiektu
					GC.Collect();

					Thread.Sleep(500);
				}
			}
			catch(Exception e)
			{
				Console.WriteLine("TestThread przerywa pracę: {0}", e.Message);
			}
		}
		static void Main(string [] args)
		{
			GCLargeObjectMain m = new GCLargeObjectMain();
			Thread testThread = new Thread(new ThreadStart(m.TestThread));
			testThread.Start();
			string input = Console.ReadLine();
			testThread.Abort();
			testThread.Join();
		}
	}
}